//------------------------------------------------------------------------------
// 
//   ACTvZT[rX TvvO
//   MappleXC^tF[XNX
//
//   Copyrights (c) 2004-2009 Advanced Core Technologies, Inc. All rights reserved.
//
//	2005/03/04 Rev.1.00 RIN J
//  2009/01/19 Rev.2.0.1.0 ISHI |SΉAГꊇvZʕ\Ή
//  2010/02/16 Rev.2.0.1.1 ISHI |S̕\̗C
//
//------------------------------------------------------------------------------

//	Using Namespace
using System;
using System.Drawing;
using System.Windows.Forms;

using SampleMX.DCService;
using AxMAPPLEXLib;

namespace SampleMX
{
	/// <summary>
	/// MapSMD ̊Tv̐łB
	/// </summary>
	/// 
	//	Definition of Class
	public class MapSMD
	{
		//------------------------------------------------------------------------------
		//	Constants
		//------------------------------------------------------------------------------

		//	[Public]

		//	n}Ɋւ郂[h
		public const Int32 MAP_CONTROL_POINTSELECT = 0;							//	H_I
		public const Int32 MAP_CONTROL_GRABBER = 1;								//	n}ړ
		public const Int32 MAP_CONTROL_ZOOMIN = 2;								//	g
		public const Int32 MAP_CONTROL_ZOOMOUT = 3;								//	k
		//	gpACReLXg̕\x
		public const Int32 TEXT_LEVEL_2 = 1;									//	x2
		public const Int32 TEXT_LEVEL_4 = 3;									//	x4
		//	gpACReLXg̔wiF/p`̓F
		public const Int32 FILL_COLOR_TRANSPARENT = -1;							//	F

		//	[Private]

		//	n}̎
		private const Int32 MAP_TYPE_JAPAN = 70;								//	{S}  (MappleX 4 ȍ~̂)
		private const Int32 MAP_TYPE_LOCAL_1 = 80;								//	n}(1) (MappleX 4 ȍ~̂)
		private const Int32 MAP_TYPE_LOCAL_2 = 90;								//	n}(2) (MappleX 4 ȍ~̂)
		private const Int32 MAP_TYPE_WIDE = 0;									//	Ln}
		private const Int32 MAP_TYPE_MIDDLE = 1;								//	n}
		private const Int32 MAP_TYPE_DETAIL = 2;								//	ڍגn}
		//	en}̍ŏ/őkڒl
		private const Int32 MAP_TYPE_JAPAN_SCALE_MIN = 2997387;					//	{S}̍ŏl
		private const Int32 MAP_TYPE_JAPAN_SCALE_MAX = 13700000;				//	{S}̍ől
		private const Int32 MAP_TYPE_LOCAL_1_SCALE_MIN = 1498701;				//	n}(1)̍ŏl
		private const Int32 MAP_TYPE_LOCAL_1_SCALE_MAX = 2997386;				//	n}(1)̍ől
		private const Int32 MAP_TYPE_LOCAL_2_SCALE_MIN = 360001;				//	n}(2)̍ŏl
		private const Int32 MAP_TYPE_LOCAL_2_SCALE_MAX = 1498700;				//	n}(2)̍ől
		private const Int32 MAP_TYPE_WIDE_SCALE_MIN = 50001;					//	Ln}̍ŏl
		private const Int32 MAP_TYPE_WIDE_SCALE_MAX = 360000;					//	Ln}̍ől
		private const Int32 MAP_TYPE_MIDDLE_SCALE_MIN = 10001;					//	n}̍ŏl
		private const Int32 MAP_TYPE_MIDDLE_SCALE_MAX = 50000;					//	n}̍ől
		private const Int32 MAP_TYPE_DETAIL_SCALE_MIN = 1000;					//	ڍגn}̍ŏl
		private const Int32 MAP_TYPE_DETAIL_SCALE_MAX = 10000;					//	ڍגn}̍ől
		//	ACReLXg̕\x̍ŏ/ől
		private const Int32 TEXT_LEVEL_MIN = 0;									//	x1
		private const Int32 TEXT_LEVEL_MAX = 5;									//	x6
		//	ACReLXg̕`X^C̍ŏ/ől
		private const Int32 TEXT_STYLE_MIN = 0;									//	X^C0
		private const Int32 TEXT_STYLE_MAX = 7;									//	X^C7
		//	gpACReLXg̕`X^C
		private const Int32 TEXT_STYLE_ONLY_ICON = 1;							//	ACR̂
		private const Int32 TEXT_STYLE_ONLY_LABEL = 2;							//	x̂
		//	gpACReLXg̃ACRhci0-79j
		private const Int32 TEXT_ICON_ID_POINT = 79;							//	Point.ico79Ƃicondef.datt@Cɒ`
		//	gpACReLXg̃x/|SȂǂ̓X^Cl
		private const Int32 FILL_STYLE_NORMAL = 0;								//	ʏix^j
		//	oH`Ŏgpłőm[h
		private const Int32 POINTS_COUNT_MAX = 300000;							//	ftHgl
		//	ܐ/[g̐
		private const Int32 LINE_WIDTH_DEFAULT = 100;							//	ftHgl
		//	n}̕\k
		private const Int32 SCALE_DEFAULT = 100000;								//	ftHgl
		//	n}ӏXg̃Zp[^
		private const String MAP_DESIGN_LIST_SEPARATOR = ",";					//	J}gp
		//	MappleX̃ReLXgj[ɓo^镶
		private const String CONTEXT_MENU_STRING_JAPAN = "k8001";		//	k8001
		private const String CONTEXT_MENU_STRING_LOCAL_1 = "k3001";	//	k3001
		private const String CONTEXT_MENU_STRING_LOCAL_2 = "k1501";	//	k1501
		private const String CONTEXT_MENU_STRING_WIDE_1 = "k201";		//	k201
		private const String CONTEXT_MENU_STRING_WIDE_2 = "k101";		//	k101
		private const String CONTEXT_MENU_STRING_MIDDLE_1 = "k51";		//	k51
		private const String CONTEXT_MENU_STRING_MIDDLE_2 = "k25番1";	//	k25番1
		private const String CONTEXT_MENU_STRING_DETAIL_1 = "k11";		//	k11
		private const String CONTEXT_MENU_STRING_DETAIL_2 = "k50001";	//	k50001
		private const String CONTEXT_MENU_STRING_DETAIL_3 = "k25001";	//	k25001
		//	Œ胉x
		private const String AREA_START_POINT_STRING = "   START   ";			//	B /  ̃X^[gn_

		//------------------------------------------------------------------------------
		//	Members
		//------------------------------------------------------------------------------

		//	[Private]

		private AxMapX m_ObjMapX;			    //	MappleX ActiveX Rg[
		private Int32 m_MapControl;			    //	n}Ɋւ郂[h
		private Int32 m_PointTextFillColor;	    //	n_`̃eLXg\̔wiF
		private Int32 m_PointIconFillColor;	    //	n_`̃ACR\̔wiF
		private Int32 m_PolygonFillColor;	    //	|S`̓F
		private Int32 m_PolygonLineColor;	    //	|S`̐̐F
		private Int32 m_DonutPolygonLineColor;	//	h[ic|S`̐̐F

		//------------------------------------------------------------------------------
		//	Methods
		//------------------------------------------------------------------------------

		//	[Public]

		//	RGB J[l\^̒lԂ
		//	p[^
		//		nRed	[IN]ړI̐FɊ܂܂  ̐̋x
		//		nGreen	[IN]ړI̐FɊ܂܂  ̐̋x
		//		nBlue	[IN]ړI̐FɊ܂܂  ̐̋x
		//	߂l
		//		ړI̐F̐ԁA΁A̐(VB RGB֐݊)
		public Int32 GetSMDColor(Int32 nRed, Int32 nGreen, Int32 nBlue)
		{
			Color RGBColor;	//	RGB \

			RGBColor = Color.FromArgb(0, nRed, nGreen, nBlue);			//	RGB \̂̍쐬

			return (RGBColor.R | RGBColor.G << 8 | RGBColor.B << 16);	//	32rbglԂ
		}

		//	C^[tFCX̏
		//	p[^
		//		axMapX  [IN]MappleX ActiveX Rg[
		//	߂l
		//		Ȃ
		public void Initialize(AxMapX axMapX)
		{
			//	MappleX ActiveX Rg[̐ݒ
			m_ObjMapX = axMapX;

			//	n}Ɋւ郂[h̐ݒ
			MapControl = MAP_CONTROL_POINTSELECT;								//	H_I ɐݒ
			//	ACReLXg̕\x̐ݒ
			TextLevel = TEXT_LEVEL_2;											//	xQ ɐݒ
			//	ACReLXg̕F̐ݒ
			TextColor = GetSMDColor(255, 0, 0);									//	ԐF ɐݒ
			//	ACReLXg̕`X^C̐ݒ
			TextStyle = TEXT_STYLE_ONLY_LABEL;									//	x̂ ɐݒ
			//	ACReLXg̃ACRID̐ݒ
			TextIconID = TEXT_ICON_ID_POINT;									//	[U`ACR 79 ɐݒ
			//	ACReLXg̔wiX^C/p`̓X^C̐ݒ
			FillStyle = FILL_STYLE_NORMAL;										//	ʏix^jɐݒ
			//	n_`̃eLXg\̔wiF̐ݒ
			PointTextFillColor = GetSMDColor(255, 255, 0);						//	F ɐݒ
			//	n_`̃ACR\̔wiF̐ݒ
			PointIconFillColor = FILL_COLOR_TRANSPARENT;						//	F ɐݒ
			//	|S`̐̐F̐ݒ
			PolygonLineColor = GetSMDColor(0,0,255);							//	 ɐݒ
			//	h[ic|S`̐̐F̐ݒ
            DonutPolygonLineColor = GetSMDColor(255, 0, 0);						//	ԐF ɐݒ
			//	ܐ/[g̐F̐ݒ
			LineColor = GetSMDColor(255, 0, 0);									//	ԐF ɐݒ
			//	ܐ/[g̐̐ݒ
			LineWidth = LINE_WIDTH_DEFAULT;										//	ftHgl 100 ɐݒ

			//	n}̎ނƕ\kڒl̐ݒ
			SetScaleforSMD(SCALE_DEFAULT);										//	ftHgl 100000 ɐݒ

			//	ReLXgj[ɒn}̕\kڒl̐ݒ胁j[o^
			m_ObjMapX.SetContextMenu(1, CONTEXT_MENU_STRING_JAPAN, 1, 0);		//	k8001
			m_ObjMapX.SetContextMenu(2, CONTEXT_MENU_STRING_LOCAL_1, 1, 0);		//	k3001
			m_ObjMapX.SetContextMenu(3, CONTEXT_MENU_STRING_LOCAL_2, 1, 0);		//	k1501
			m_ObjMapX.SetContextMenu(4, CONTEXT_MENU_STRING_WIDE_1, 1, 0);		//	k201
			m_ObjMapX.SetContextMenu(5, CONTEXT_MENU_STRING_WIDE_2, 1, 0);		//	k101
			m_ObjMapX.SetContextMenu(6, CONTEXT_MENU_STRING_MIDDLE_1, 1, 0);	//	k51
			m_ObjMapX.SetContextMenu(7, CONTEXT_MENU_STRING_MIDDLE_2, 1, 0);	//	k25番1
			m_ObjMapX.SetContextMenu(8, CONTEXT_MENU_STRING_DETAIL_1, 1, 0);	//	k11
			m_ObjMapX.SetContextMenu(9, CONTEXT_MENU_STRING_DETAIL_2, 1, 0);	//	k50001
			m_ObjMapX.SetContextMenu(10, CONTEXT_MENU_STRING_DETAIL_3, 1, 0);	//	k25001

			return;
		}

		//	[gvZ / ŒZ[gvZ ̋vZR}h\̏`悷
		//	p[^
		//		DCCommand	[IN]vZR}h\
		//	߂l
		//		true	vZR}h\̏̕`ɐ
		//		false	vZR}h\̏̕`Ɏs
		public bool DrawDistCalcRoute(DCCommand DCCommand)
		{
			String lpszLabal;	//	`悷郉x
			Int32 nLon;			//	ox
			Int32 nLat;			//	ܓx
			Int32 nCustomID;	//	JX^ ID
			Int32 nPoints;		//	|Cg
			Int32 i;			//	JE^
			bool bDraw;			//	`挋

			nPoints = DCCommand.Pnts.Length;	//	|Cg̎擾
			//	ő|Cg𒴂ĂȂH
			if (nPoints > POINTS_COUNT_MAX)
				return false;

			//	ACReLXg̐ݒ
			nCustomID = m_ObjMapX.GetCustomCount() + 1;	//	JX^ ID

			//	oH̕`̊Jn
			for (i = 0; i < nPoints; i++) {
				nLon = Convert.ToInt32(Convert.ToDouble(DCCommand.Pnts[i].Lon) * 3600000.0F);	//	ox
				nLat = Convert.ToInt32(Convert.ToDouble(DCCommand.Pnts[i].Lat) * 3600000.0F);	//	ܓx
				bDraw = m_ObjMapX.AddPolyLine(nCustomID, ref nLon, ref nLat, 0);
				//	oH̕`ɎsĂȂH
				if (!bDraw) {
					MessageBox.Show("|Cgz̕`Ɏs܂B", "G[", 
						MessageBoxButtons.OK, MessageBoxIcon.Error);
					return false;
				}
			}

			//	n_̕`̊Jn
			for (i = 0; i < DCCommand.Locs.Length; i++) {
				lpszLabal = (i + 1) + "  " + DCCommand.Locs[i].Time + "" + "  " + DCCommand.Locs[i].Dist.ToString("###,##0");
				bDraw = DrawPoint(Convert.ToDouble(DCCommand.Locs[i].Lon), Convert.ToDouble(DCCommand.Locs[i].Lat), lpszLabal);
				//	n_̕`ɎsĂȂH
				if (!bDraw) {
					MessageBox.Show("P[Vz̕`Ɏs܂B", "G[", 
						MessageBoxButtons.OK, MessageBoxIcon.Error);
					return false;
				}
			}
			return true;	//	n}`̐
		}

		//	B / vZʂ`悷
		//	p[^
        //		points  	[IN]|Cg\̂̔z
        //      geoPoint    [IN]Sʒu
        //	߂l
		//		true	`ɐ
		//		false	`Ɏs
        public bool DrawDistCalcArea(SampleMX.DCService.Pnt[] points, SampleMX.DCService.GeoPnt geoPoint)
		{
			Int32 i;			        //	JE^
			String labal;	            //	`悷郉x
			Int32 customID;	            //	JX^ ID
			Int32 pointCount;           //	|Cg
			bool resultDraw;		    //	`挋
			Int32 countDelimiter = 0;	//  ؂̃JE^

			//	ő|Cg𒴂ĂȂׂ
			pointCount = points.Length;	//	|Cg̎擾
			if (pointCount > POINTS_COUNT_MAX)
				return false;

			//	ACReLXg̐ݒ
			customID = m_ObjMapX.GetCustomCount() + 1;	            
			LineColor = PolygonLineColor;				//  |S̐FύX
			m_ObjMapX.SetFillColor(PolygonFillColor);	//	|S`̓Fݒ

			//	|S̕`̊Jn
			for (i = 0; i < pointCount; i++) {

				double lon = Convert.ToDouble(points[i].Lon);	//	|Cǧox
				double lat = Convert.ToDouble(points[i].Lat);	//	|Cǧox

                
				if (lon == 0 && lat == 0) {				//	؂̏

					countDelimiter += 1;
					customID = m_ObjMapX.GetCustomCount() + 1;	            

					if (countDelimiter == 1) {			//	؂肪
						//  ̃|S̓h[ic|S
						LineColor = DonutPolygonLineColor;
					} else {							//	؂肪P傫
						//  ̃|S͕ʂ̃|S
						LineColor = PolygonLineColor;
					}
                } else {								//	|S̏
					countDelimiter = 0;

					Int32 lonSec = Convert.ToInt32(Convert.ToDouble(points[i].Lon) * 3600000.0F);	//	~bPʂ̌ox
					Int32 latSec = Convert.ToInt32(Convert.ToDouble(points[i].Lat) * 3600000.0F);	//	~bPʂ̈ܓx

					resultDraw = m_ObjMapX.AddPolyLine(customID, ref lonSec, ref latSec, 0);
					//	|S̕`Ɏsꍇ
					if (!resultDraw) {
						return false;
					}
				}
			}

			//	ACReLXg̐ݒ
			customID = m_ObjMapX.GetCustomCount() + 1;	//	JX^ ID

			//	n_̕`̊Jn(X^[gn_)
			labal = AREA_START_POINT_STRING;
			resultDraw = DrawPoint(Convert.ToDouble(geoPoint.Lon), Convert.ToDouble(geoPoint.Lat), labal);
			//	n_̕`ɎsĂꍇ
			if (!resultDraw) {
				MessageBox.Show("X^[gn_̕`Ɏs܂B", "G[", 
					MessageBoxButtons.OK, MessageBoxIcon.Error);
				return false;
			}

			return true;	//	n}`̐
		}

        //	ГꊇvZʂ`悷
        //	p[^
        //		locations	[IN]P[V\̂̔z
        //      geoPoint    [IN]Sʒu
        //	߂l
        //		true	`ɐ
        //		false	`Ɏs
        public bool DrawDistCalcOneWay(SampleMX.DCService.Loc[] locations, SampleMX.DCService.GeoPnt geoPoint) {
            String labal;	    //	`悷郉x
            Int32 i;			//	JE^
            Int32 customID;     //	JX^ ID
            bool resultDraw;    //	`挋
           
            //	ACReLXg̐ݒ
            m_ObjMapX.SetFillColor(PolygonFillColor);	//	|S`̓Fݒ
            customID = m_ObjMapX.GetCustomCount() + 1;	//	JX^ ID

            //	n_̕`̊Jn(P[Vꍇ)
            if (locations.Length > 1) {
                for (i = 0; i < locations.Length; i++) {
                    labal = (i + 1) + "  " + locations[i].Time + "" + "  " + locations[i].Dist.ToString("###,##0");
                    resultDraw = DrawPoint(Convert.ToDouble(locations[i].Lon), Convert.ToDouble(locations[i].Lat), labal);
                    //	n_̕`ɎsĂȂH
                    if (!resultDraw) {
                        MessageBox.Show("P[Vz̕`Ɏs܂B", "G[",
                            MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return false;
                    }
                }
            }

            //	n_̕`̊Jn(X^[gn_)
            labal = AREA_START_POINT_STRING;
            resultDraw = DrawPoint(
                Convert.ToDouble(geoPoint.Lon),
                Convert.ToDouble(geoPoint.Lat),
                labal
                );
            //	n_̕`ɎsĂȂH
            if (!resultDraw) {
                MessageBox.Show("X^[gn_̕`Ɏs܂B", "G[",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
            return true;	//	n}`̐
        }

        //	n}ɓH_\
		//	p[^
		//		DCCommand	[IN]vZR}h\
		//	߂l
		//		true	H_̕\ɐ
		//		false	H_̕\Ɏs
		public bool DrawLastLoc(DCCommand DCCommand)
		{
			Int32 nElement;	//	QƂvfԍ
			bool bDraw;		//	`挋

			nElement = DCCommand.Locs.Length - 1;	//	Ō̗vfԍ̎擾

			//	n_̕`̊Jn(Ō̒n_)
			bDraw = DrawPoint(
				Convert.ToDouble(DCCommand.Locs[nElement].Lon), 
				Convert.ToDouble(DCCommand.Locs[nElement].Lat), 
				Convert.ToString(nElement + 1)
				);
			//	n_̕`ɎsĂȂH
			if (!bDraw) {
				MessageBox.Show("P[V̕`Ɏs܂B", "G[", 
					MessageBoxButtons.OK, MessageBoxIcon.Error);
				return false;
			}
			return true;	//	n}`̐
		}

		//	n}̒S_ݒ肷
		//	p[^
		//		nLon	[IN]S_ɐݒ肷ox
		//		nLat	[IN]S_ɐݒ肷ܓx
		//	߂l
		//		Ȃ
		public void PanMap(Int32 nLon, Int32 nLat)
		{
			m_ObjMapX.SetPosition(nLon, nLat);
			return;
		}

		//	n}̃IuWFNgSč폜
		//	p[^
		//		Ȃ
		//	߂l
		//		Ȃ
		public void ClearMap()
		{
			m_ObjMapX.DeleteAllCustom();
			return;
		}

		//	n}̕\kڒln}̎ނƕ\kڒlݒ肷( SMD p̕`kڏ)
		//	p[^
		//		nScale  [IN]k X1  X
		//	߂l
		//		Ȃ
		public void SetScaleforSMD(Int32 nScale)
		{
			//	n}̕\kڒl؂ւn}̎ނI
			if (nScale >= MAP_TYPE_DETAIL_SCALE_MIN && nScale <= MAP_TYPE_DETAIL_SCALE_MAX) 
				MapType = MAP_TYPE_DETAIL;	//	ڍגn}
			else if (nScale >= MAP_TYPE_MIDDLE_SCALE_MIN && nScale <= MAP_TYPE_MIDDLE_SCALE_MAX) 
				MapType = MAP_TYPE_MIDDLE;	//	n}
			else if (nScale >= MAP_TYPE_WIDE_SCALE_MIN && nScale <= MAP_TYPE_WIDE_SCALE_MAX)
				MapType = MAP_TYPE_WIDE;	//	Ln}
			else if (nScale >= MAP_TYPE_LOCAL_2_SCALE_MIN && nScale <= MAP_TYPE_LOCAL_2_SCALE_MAX) 
				MapType = MAP_TYPE_LOCAL_2;	//	n}(2)
			else if (nScale >= MAP_TYPE_LOCAL_1_SCALE_MIN && nScale <= MAP_TYPE_LOCAL_1_SCALE_MAX) 
				MapType = MAP_TYPE_LOCAL_1;	//	n}(1)
			else if (nScale >= MAP_TYPE_JAPAN_SCALE_MIN && nScale <= MAP_TYPE_JAPAN_SCALE_MAX) 
				MapType = MAP_TYPE_JAPAN;	//	{S}
			else
				return;						//	ȊO

			//	n}̕\kڒlݒ
			MapScale = nScale;

			return;
		}

		//	n}ӏXg쐬
		//	p[^
		//		Ȃ
		//	߂l
		//		n}ӏXg
		//	l
		//		n}ӏXǵu,v؂Œn}ӏA񃊃XgB
		//		n}ӏ݂ȂAn}ӏ̎擾Ɏsꍇ́A
		//		̕񂪕Ԃ܂B
		public String GetMapDesignList()
		{
			Int16 i;						//	JE^
			Int16 nMapDesignCount;			//	n}ӏ
			String lpszMapDesignName = "";	//	n}ӏ擾pobt@
			String lpszMapDesignList = "";	//	n}ӏXg
			String[] MapDesignArray = null;	//	n}ӏi[z

			//	n}ӏ̎擾
			nMapDesignCount = m_ObjMapX.GetMdiGroupCount();

			//	n}ӏ݂͑邩H
			if (nMapDesignCount == 0)
				return "";

			//	n}ӏi[zmۂ
			MapDesignArray = new String[nMapDesignCount];

			//	n}ӏ擾Ĕz̊evfɐݒ肷
			for (i = 0;  i < nMapDesignCount; i++) {
				//	n}ӏ̎擾ɐH
				if (!m_ObjMapX.GetMdiGroupName(i, ref lpszMapDesignName))
					return "";

				//	n}ӏz̗vfɐݒ
				MapDesignArray[i] = lpszMapDesignName;
			}

			//	z񂩂n}ӏXg쐬
			lpszMapDesignList = String.Join(MAP_DESIGN_LIST_SEPARATOR, MapDesignArray, 0, nMapDesignCount);

			//	쐬
			return lpszMapDesignList;
		}

		//	[Private]

		//	n}ɒn_`悷
		//	p[^
		//		ldX			[IN]`悷n_̌ox
		//		ldY			[IN]`悷n_̈ܓx
		//		lpszLabel	[IN]`悷郉x
		//	߂l
		//		true	n_̕`ɐ
		//		false	n_̕`Ɏs
		private bool DrawPoint(double ldX, double ldY, String lpszLabel)
		{
			Int32 nLon;			//	ox
			Int32 nLat;			//	ܓx
			Int32 nCustomID;	//	JX^ ID
			bool bDraw;			//	`挋

			bDraw = false;	//	߂l̏

			//	ox/ܓxl̕ϊ
			nLon = Convert.ToInt32(ldX * 3600000.0F);	//	ox
			nLat = Convert.ToInt32(ldY * 3600000.0F);	//	ܓx

			//	ACReLXg̐ݒ
			TextStyle = TEXT_STYLE_ONLY_LABEL;								//	eLXg\̂߂ x̂ ɐݒ
			m_ObjMapX.SetFillColor(PointTextFillColor);						//	eLXg\̔wiFݒ
			nCustomID = m_ObjMapX.GetCustomCount() + 1;						//	JX^ ID

			bDraw = m_ObjMapX.AddText(nCustomID, nLon, nLat, lpszLabel);	//	eLXg\̎s

			//	eLXg\ɐH
			if (bDraw) {
				//   ACReLXg̐ݒ
				TextStyle = TEXT_STYLE_ONLY_ICON;							//	ACR\̂߂ ACR̂ ɐݒ
				m_ObjMapX.SetFillColor(PointIconFillColor);					//	ACR\̔wiFݒ
				nCustomID = m_ObjMapX.GetCustomCount() + 1;					//	JX^ ID

				bDraw = m_ObjMapX.AddText(nCustomID, nLon, nLat, "");		//	ACR\̎s
			}

			return bDraw;
		}

		//------------------------------------------------------------------------------
		//	Properties
		//------------------------------------------------------------------------------

		//	[Public]

		//	n}Ɋւ郂[h擾/ݒ肷
		public Int32 MapControl
		{
			//	擾
			get
			{
				return m_MapControl;
			}
			//	ݒ
			set
			{
				//	[hl MappleX Rg[̒n}샂[hƃJ[\̐ݒs
				switch (value)
				{
					case MAP_CONTROL_POINTSELECT :	//	H_I
						m_ObjMapX.ToolType = 1;	//	JX^I[h / J[\
						break;
					case MAP_CONTROL_GRABBER :		//	n}ړ
						m_ObjMapX.ToolType = 0;	//	n}ړ[h / Oo[J[\
						break;
					case MAP_CONTROL_ZOOMIN :		//	g
						m_ObjMapX.ToolType = 2;	//	ACReLXg̓[h / \J[\
						break;
					case MAP_CONTROL_ZOOMOUT :		//	k
						m_ObjMapX.ToolType = 2;	//	ACReLXg̓[h / \J[\
						break;
					default :						//	ȊO
						return;
				}
				//	[hl̐ݒ
				m_MapControl = value;
			}
		}

		//	n}̎ނ擾/ݒ肷
		public Int16 MapType
		{
			//	擾
			get
			{
				return m_ObjMapX.GetMapType();
			}
			//	ݒ
			set
			{
				//	n}̎ނ̒l͐ȒlH
				if ((value == MAP_TYPE_JAPAN) || 
					(value == MAP_TYPE_LOCAL_1) ||
					(value == MAP_TYPE_LOCAL_2) ||
					(value == MAP_TYPE_WIDE) ||
					(value == MAP_TYPE_MIDDLE) ||
					(value == MAP_TYPE_DETAIL)) 
					//	n}̎ނ̐ݒ
					m_ObjMapX.SetMapType(value);
			}
		}

		//	n}̕\kڒl擾/ݒ肷
		public Int32 MapScale
		{
			//	擾
			get
			{
				return m_ObjMapX.GetScale();
			}
			//	ݒ
			set
			{
				//	݂̒n}̎ނƏƍāAݒ肷kڒl͐ȒlH
				if (value >= MAP_TYPE_DETAIL_SCALE_MIN && value <= MAP_TYPE_DETAIL_SCALE_MAX) {
					if (MapType != MAP_TYPE_DETAIL)		//	ڍגn}
						return;
				} else if (value >= MAP_TYPE_MIDDLE_SCALE_MIN && value <= MAP_TYPE_MIDDLE_SCALE_MAX) {
					if (MapType != MAP_TYPE_MIDDLE)		//	n}
						return;
				} else if (value >= MAP_TYPE_WIDE_SCALE_MIN && value <= MAP_TYPE_WIDE_SCALE_MAX) {
					if (MapType != MAP_TYPE_WIDE)		//	Ln}
						return;
				} else if (value >= MAP_TYPE_LOCAL_2_SCALE_MIN && value <= MAP_TYPE_LOCAL_2_SCALE_MAX) {
					if (MapType != MAP_TYPE_LOCAL_2)	//	n}(2)
						return;
				} else if (value >= MAP_TYPE_LOCAL_1_SCALE_MIN && value <= MAP_TYPE_LOCAL_1_SCALE_MAX) {
					if (MapType != MAP_TYPE_LOCAL_1)	//	n}(1)
						return;
				} else if (value >= MAP_TYPE_JAPAN_SCALE_MIN && value <= MAP_TYPE_JAPAN_SCALE_MAX) {
					if (MapType != MAP_TYPE_JAPAN)		//	{S}
						return;
				} else {
					return;
				}
				//	kڒl̐ݒ
				m_ObjMapX.SetScale(value);
			}
		}

		//	n}ӏ擾/ݒ肷
		public String MapDesign
		{
			//	擾
			get
			{
				String lpszMapDesignPath = "";
				String lpszMapDesignName = "";

				//	ݎgpĂn}ӏ擾
				m_ObjMapX.GetMdiGroup(ref lpszMapDesignPath, ref lpszMapDesignName);
				//	݂̒n}ӏԂ
				return lpszMapDesignName;
			}
			//	ݒ
			set
			{
				//	w肵n}ӏɐݒ
				m_ObjMapX.SetMdiGroup(value);
			}
		}

		//	ACReLXg̕\x擾/ݒ肷
		public Int16 TextLevel
		{
			//	擾
			get
			{
				return m_ObjMapX.GetTextLevel();
			}
			//	ݒ
			set
			{
				//	ACReLXg̕\xl͈͓̔H
				if ((value >= TEXT_LEVEL_MIN) && (value <= TEXT_LEVEL_MAX)) 
					m_ObjMapX.SetTextLevel(value);
			}
		}

		//	ACReLXg̕F擾/ݒ肷
		public Int32 TextColor
		{
			//	擾
			get
			{
				return m_ObjMapX.GetTextColor();
			}
			//	ݒ
			set
			{
				//	RGB l͈͓̔H
				if ((value >= Color.FromArgb(0, 0, 0, 0).ToArgb()) && (value <= Color.FromArgb(0, 255, 255, 255).ToArgb()))
					m_ObjMapX.SetTextColor(value);
			}
		}

		//	ACReLXg̕`X^C擾/ݒ肷
		public Int16 TextStyle
		{
			//	擾
			get
			{
				return m_ObjMapX.GetTextStyle();
			}
			//	ݒ
			set
			{
				//	ACReLXg̕`X^Cl͈̔͂H
				if ((value >= TEXT_STYLE_MIN) && (value <= TEXT_STYLE_MAX)) 
					m_ObjMapX.SetTextStyle(value);
			}
		}

		//	ACReLXg̃ACRID擾/ݒ肷
		public Int32 TextIconID
		{
			//	擾
			get
			{
				return m_ObjMapX.GetTextIconID();
			}
			//	ݒ
			set
			{
				//	ACR ID l͈͓̔H
				if ((value >= 0) && (value < m_ObjMapX.GetIconCount()))
					m_ObjMapX.SetTextIconID(value);
			}
		}

		//	ACReLXg̔wiX^C/p`̓X^C擾/ݒ肷
		public Int16 FillStyle
		{
			//	擾
			get
			{
				return m_ObjMapX.GetFillStyle();
			}
			//	ݒ
			set
			{
				//	X^Cl͈͓̔H
				if ((value >= 0) && (value < m_ObjMapX.GetFillStyleCount()))
					m_ObjMapX.SetFillStyle(value);
			}
		}

		//	n_`̃eLXg\̔wiF擾/ݒ肷
		public Int32 PointTextFillColor
		{
			//	擾
			get
			{
				return m_PointTextFillColor;
			}
			//	ݒ
			set
			{
				//	RGB l͈͓̔H
				if ((value >= FILL_COLOR_TRANSPARENT) && (value <= Color.FromArgb(0, 255, 255, 255).ToArgb()))
					m_PointTextFillColor = value;
			}
		}

		//	n_`̃ACR\̔wiF擾/ݒ肷
		public Int32 PointIconFillColor
		{
			//	擾
			get
			{
				return m_PointIconFillColor;
			}
			//	ݒ
			set
			{
				//	RGB l͈͓̔H
				if ((value >= FILL_COLOR_TRANSPARENT) && (value <= Color.FromArgb(0, 255, 255, 255).ToArgb()))
					m_PointIconFillColor = value;
			}
		}

		//	|S`̓F擾/ݒ肷
		public Int32 PolygonFillColor
		{
			//	擾
			get
			{
				return m_PolygonFillColor;
			}
			//	ݒ
			set
			{
				//	RGB l͈͓̔H
				if ((value >= FILL_COLOR_TRANSPARENT) && (value <= Color.FromArgb(0, 255, 255, 255).ToArgb()))
					m_PolygonFillColor = value;
			}
		}

		//	ܐ/[g̐F擾/ݒ肷
		public Int32 LineColor
		{
			//	擾
			get
			{
				return m_ObjMapX.GetLineColor();
			}
			//	ݒ
			set
			{
				//	RGBl͈͓̔H
				if ((value >= Color.FromArgb(0, 0, 0, 0).ToArgb()) && (value <= Color.FromArgb(0, 255, 255, 255).ToArgb()))
					m_ObjMapX.SetLineColor(value);
			}
		}

		//	ܐ/[g̐擾/ݒ肷
		public Int32 LineWidth
		{
			//	擾
			get
			{
				return m_ObjMapX.GetLineWidth();
			}
			//	ݒ
			set
			{
				m_ObjMapX.SetLineWidth(value);
			}
		}

        public int PolygonLineColor {
            get {
				return m_PolygonLineColor;
			}
			set
			{
				//	RGB l͈͓̔H
				if ((value >= FILL_COLOR_TRANSPARENT) && (value <= Color.FromArgb(0, 255, 255, 255).ToArgb()))
					m_PolygonLineColor = value;
            }
        }

        public int DonutPolygonLineColor {
            get {
				return m_DonutPolygonLineColor;
			}
			set
			{
				//	RGB l͈͓̔H
				if ((value >= FILL_COLOR_TRANSPARENT) && (value <= Color.FromArgb(0, 255, 255, 255).ToArgb()))
					m_DonutPolygonLineColor = value;
            }
        }
	}
}

//	End of Source
