//------------------------------------------------------------------------------
// 
//   ACTvZT[rX TvvO
//   ڑT[oݒtH[NX
//
//   Copyrights (c) 2004-2009 Advanced Core Technologies, Inc. All rights reserved.
//
//	2005/03/04 Rev.1.00 RIN J
//
//------------------------------------------------------------------------------

//	Using Namespace
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace SampleMX
{
	/// <summary>
	/// ServerForm ̊Tv̐łB
	/// </summary>
	/// 
	//	Definition of Class
	public class ServerForm : System.Windows.Forms.Form
	{
		//------------------------------------------------------------------------------
		//	Constants
		//------------------------------------------------------------------------------

		//	[Public]

		public const Int32 RESULT_BUTTON_UPDATE = 1;	//	f[^XV{^({^)̔l
		public const Int32 RESULT_BUTTON_CANCEL = 0;	//	f[^XV{^({^ȊÕ{^)̔l

		//------------------------------------------------------------------------------
		//	Members
		//------------------------------------------------------------------------------

		//	[Private]

		private DCAdmin.NWInfo m_NWInfo;		//	vZpHf[^NX
		private DCService.Environ m_Environ;	//	ݒNX
		private Int32 m_ResultButton;			//	{^l

		//	[Internal]

		internal System.Windows.Forms.TextBox textDCAdminURL;
		internal System.Windows.Forms.TextBox textUUID;
		internal System.Windows.Forms.TextBox textUserID;
		internal System.Windows.Forms.Label labelExplanation;
		internal System.Windows.Forms.Button buttonNext;
		internal System.Windows.Forms.Button buttonBefore;
		internal System.Windows.Forms.Button buttonCancel;
		internal System.Windows.Forms.Button buttonFinal;
		internal System.Windows.Forms.Label labelLine;
		internal System.Windows.Forms.Label labelDCAdminURL;
		internal System.Windows.Forms.Label labelUserID;
		internal System.Windows.Forms.Label labelUUID;

		//	[Private]

		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		//------------------------------------------------------------------------------
		//	Methods
		//------------------------------------------------------------------------------

		//	[Public]

		//	RXgN^
		//	p[^
		//		Environ	[IN]ݒIuWFNg
		//		NWInfo	[IN]vZpHf[^IuWFNg
		public ServerForm(
				DCService.Environ Environ, 
				DCAdmin.NWInfo NWInfo
			)
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
			//	ݒ
			m_Environ = Environ;
			m_NWInfo = NWInfo;
		}

		//	{^l擾
		//	p[^
		//		Ȃ
		//	߂l
		//		{^l
		//	l
		//		RESULT_BUTTON_UPDATE	f[^XV{^({^)̔l
		//		RESULT_BUTTON_CANCEL	f[^XV{^({^ȊÕ{^)̔l
		public Int32 GetResultButton()
		{
			return m_ResultButton;
		}

		//	[Protected]

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.textDCAdminURL = new System.Windows.Forms.TextBox();
			this.textUUID = new System.Windows.Forms.TextBox();
			this.textUserID = new System.Windows.Forms.TextBox();
			this.labelExplanation = new System.Windows.Forms.Label();
			this.buttonNext = new System.Windows.Forms.Button();
			this.buttonBefore = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.buttonFinal = new System.Windows.Forms.Button();
			this.labelLine = new System.Windows.Forms.Label();
			this.labelDCAdminURL = new System.Windows.Forms.Label();
			this.labelUserID = new System.Windows.Forms.Label();
			this.labelUUID = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// textDCAdminURL
			// 
			this.textDCAdminURL.AutoSize = false;
			this.textDCAdminURL.Location = new System.Drawing.Point(128, 88);
			this.textDCAdminURL.Name = "textDCAdminURL";
			this.textDCAdminURL.Size = new System.Drawing.Size(335, 19);
			this.textDCAdminURL.TabIndex = 6;
			this.textDCAdminURL.Text = "";
			// 
			// textUUID
			// 
			this.textUUID.AutoSize = false;
			this.textUUID.Location = new System.Drawing.Point(128, 60);
			this.textUUID.Name = "textUUID";
			this.textUUID.PasswordChar = '*';
			this.textUUID.Size = new System.Drawing.Size(192, 19);
			this.textUUID.TabIndex = 4;
			this.textUUID.Text = "";
			// 
			// textUserID
			// 
			this.textUserID.AutoSize = false;
			this.textUserID.Location = new System.Drawing.Point(128, 32);
			this.textUserID.Name = "textUserID";
			this.textUserID.Size = new System.Drawing.Size(192, 19);
			this.textUserID.TabIndex = 2;
			this.textUserID.Text = "";
			// 
			// labelExplanation
			// 
			this.labelExplanation.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.labelExplanation.Location = new System.Drawing.Point(8, 8);
			this.labelExplanation.Name = "labelExplanation";
			this.labelExplanation.Size = new System.Drawing.Size(481, 16);
			this.labelExplanation.TabIndex = 0;
			this.labelExplanation.Text = "[UIDApX[hAǗT[oURL͂āuցv{^ĂB";
			this.labelExplanation.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// buttonNext
			// 
			this.buttonNext.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.buttonNext.Location = new System.Drawing.Point(290, 162);
			this.buttonNext.Name = "buttonNext";
			this.buttonNext.Size = new System.Drawing.Size(96, 24);
			this.buttonNext.TabIndex = 10;
			this.buttonNext.Text = "(&N) >";
			this.buttonNext.Click += new System.EventHandler(this.buttonNext_Click);
			// 
			// buttonBefore
			// 
			this.buttonBefore.Enabled = false;
			this.buttonBefore.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.buttonBefore.Location = new System.Drawing.Point(186, 162);
			this.buttonBefore.Name = "buttonBefore";
			this.buttonBefore.Size = new System.Drawing.Size(96, 24);
			this.buttonBefore.TabIndex = 9;
			this.buttonBefore.Text = "< ߂(&B)";
			// 
			// buttonCancel
			// 
			this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonCancel.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.buttonCancel.Location = new System.Drawing.Point(82, 162);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.Size = new System.Drawing.Size(96, 24);
			this.buttonCancel.TabIndex = 8;
			this.buttonCancel.Text = "ݾ";
			// 
			// buttonFinal
			// 
			this.buttonFinal.Enabled = false;
			this.buttonFinal.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.buttonFinal.Location = new System.Drawing.Point(394, 162);
			this.buttonFinal.Name = "buttonFinal";
			this.buttonFinal.Size = new System.Drawing.Size(96, 24);
			this.buttonFinal.TabIndex = 11;
			this.buttonFinal.Text = "(&F)";
			// 
			// labelLine
			// 
			this.labelLine.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.labelLine.Location = new System.Drawing.Point(8, 152);
			this.labelLine.Name = "labelLine";
			this.labelLine.Size = new System.Drawing.Size(481, 1);
			this.labelLine.TabIndex = 7;
			// 
			// labelDCAdminURL
			// 
			this.labelDCAdminURL.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.labelDCAdminURL.Location = new System.Drawing.Point(36, 88);
			this.labelDCAdminURL.Name = "labelDCAdminURL";
			this.labelDCAdminURL.Size = new System.Drawing.Size(88, 19);
			this.labelDCAdminURL.TabIndex = 5;
			this.labelDCAdminURL.Text = "ǗT[oURLF";
			this.labelDCAdminURL.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// labelUserID
			// 
			this.labelUserID.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.labelUserID.Location = new System.Drawing.Point(36, 32);
			this.labelUserID.Name = "labelUserID";
			this.labelUserID.Size = new System.Drawing.Size(88, 19);
			this.labelUserID.TabIndex = 1;
			this.labelUserID.Text = "[UIDF";
			this.labelUserID.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// labelUUID
			// 
			this.labelUUID.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.labelUUID.Location = new System.Drawing.Point(36, 60);
			this.labelUUID.Name = "labelUUID";
			this.labelUUID.Size = new System.Drawing.Size(88, 19);
			this.labelUUID.TabIndex = 3;
			this.labelUUID.Text = "pX[hF";
			this.labelUUID.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// ServerForm
			// 
			this.AcceptButton = this.buttonNext;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.CancelButton = this.buttonCancel;
			this.ClientSize = new System.Drawing.Size(498, 194);
			this.Controls.Add(this.textDCAdminURL);
			this.Controls.Add(this.textUUID);
			this.Controls.Add(this.textUserID);
			this.Controls.Add(this.labelExplanation);
			this.Controls.Add(this.buttonNext);
			this.Controls.Add(this.buttonBefore);
			this.Controls.Add(this.buttonCancel);
			this.Controls.Add(this.buttonFinal);
			this.Controls.Add(this.labelLine);
			this.Controls.Add(this.labelDCAdminURL);
			this.Controls.Add(this.labelUserID);
			this.Controls.Add(this.labelUUID);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "ServerForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "vZpHf[^IEBU[h - 1 / 2";
			this.Load += new System.EventHandler(this.ServerForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		//------------------------------------------------------------------------------
		//	Event Handlers
		//------------------------------------------------------------------------------

		//	tH[̏
		private void ServerForm_Load(object sender, System.EventArgs e)
		{
			m_ResultButton = RESULT_BUTTON_CANCEL;	//	{^l̏
			//	UIɃf[^[h
			textUserID.Text = m_Environ.UserID;		//	[UID
			textDCAdminURL.Text = m_Environ.WSUrl;	//	ǗT[oURL
		}

		//	vZT[rXp UI XV
		private void buttonNext_Click(object sender, System.EventArgs e)
		{

			DCAdmin.ACTDCADMIN DCAdminServer;	//	ǗT[oNX
			DCAdmin.Environ DCAdminEnviron;		//	ǗT[oݒNX
			DCAdmin.NWInfo[] NWInfos;			//	vZpHf[^IuWFNgz̐擪vf
			RoadForm FinalPage;					//	EBU[h 2 y[W(gp\ȌvZpHf[^\)
			DialogResult Result;				//	vZpHf[^ݒtH[̌ʔl
			Int32 nNWInfosResultIndex;			//	vZpHf[^IuWFNgz̑Ivfԍ

			//	CX^X̍쐬
			DCAdminServer = new DCAdmin.ACTDCADMIN();	//	ǗT[oIuWFNg
			DCAdminEnviron = new DCAdmin.Environ();	//	ǗT[oݒIuWFNg
			//	ݒ
			try
			{
				DCAdminServer.Url = textDCAdminURL.Text;		//	ǗT[o URL
			}
			catch (Exception ex)
			{
				MessageBox.Show("ǗT[o URL http:// ͂ĂB" + "\r\n" + ex.Message, "G[", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			DCAdminEnviron.UserID = textUserID.Text;	//	ڑT[o USERID
			DCAdminEnviron.UUID = textUUID.Text;		//	ڑT[o UUID

			try
			{
				NWInfos = null;
				//	gpłvZpHf[^擾łH
				if (!DCAdminServer.GetUsableNWInfos(DCAdminEnviron, ref NWInfos)) {
					MessageBox.Show("vZpHf[^̎擾Ɏs܂B" + "\r\n" + 
					"[UIDApX[hAǗT[oURL͂ĂB", 
					"ǗT[o", MessageBoxButtons.OK, MessageBoxIcon.Error);
					return;
				}
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "ǗT[o", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}

			//	vZpHf[^IuWFNgzvZpHf[^ݒtH[֓n
			FinalPage = new RoadForm(NWInfos, m_NWInfo);	//	CX^X̍쐬
			//	EBhE̕\
			Visible = false;	//	\
			//	2 y[Wڂ̕\
			Result = FinalPage.ShowDialog(this);
			if (Result == DialogResult.OK) {
				//	uv{^
				nNWInfosResultIndex = FinalPage.GetNWInfosResultIndex();	//	z̑Ivfԍ擾
				//	z̗vf͑IĂ邩H
				if (nNWInfosResultIndex != RoadForm.UNSELECT_INDEX) {
					//	ݒIuWFNg̍XV
					m_Environ.UserID = textUserID.Text;		//	USERID
					m_Environ.UUID = textUUID.Text;			//	UUID
					m_Environ.WSUrl = textDCAdminURL.Text;	//	ǗT[oURL
					//	vZpHf[^IuWFNg̍XV
					m_NWInfo.Note = NWInfos[nNWInfosResultIndex].Note;
					m_NWInfo.Folder = NWInfos[nNWInfosResultIndex].Folder;
					m_NWInfo.NWID = NWInfos[nNWInfosResultIndex].NWID;
					m_NWInfo.NWID_WithoutSpeed = NWInfos[nNWInfosResultIndex].NWID_WithoutSpeed;
					m_NWInfo.IsDetailExist = NWInfos[nNWInfosResultIndex].IsDetailExist;
					m_NWInfo.IsTollExist = NWInfos[nNWInfosResultIndex].IsTollExist;
					//	f[^XV{^
					m_ResultButton = RESULT_BUTTON_UPDATE;	//	{^ꂽƂĂяoɒʒm
				}
				Close();	//	N[Y
			} else if (Result == DialogResult.Cancel) {
				//	uLZv{^
				Close();	//	N[Y
			} else {
				//	u߂v{^
				Visible = true;		//	\
			}
			FinalPage.Dispose();	//	j
		}
	}
}

//	End of Source
